#ifndef IMMAGINE_H
#define IMMAGINE_H

class ImageClassRgb
{
private:
    int width;//larghezza dell' immagine
    int height;//altezza dell' immagine
    
    //Vettore di pixel che conterr i dati dell' immagine
    //image  un vettore di dimensione width*height 
    unsigned char *image;
public:
    // costruttore di default
    ImageClassRgb();
    // costruisce un oggetto a partire dalle dimensioni dellimmagine
    ImageClassRgb(int r, int c);

    // distruttore
    ~ImageClassRgb();
    // ridimensiona loggetto
    void resize(int r, int c);
    int getHeight();
    int getWidth();
    
    void setHeight(int h);
    void setWidth(int w);

    unsigned char *getInternalPointer()
    { return image; }
};

class ImageClassMono
{
private:
    int width;//larghezza dell' immagine
    int height;//altezza dell' immagine
    
    //Vettore di pixel che conterr i dati dell' immagine
    //image  un vettore di dimensione width*height 
    unsigned char *image;
public:
    // costruttore di default
    ImageClassMono();
    // costruisce un oggetto a partire dalle dimensioni dellimmagine
    ImageClassMono(int r, int c);

    // distruttore
    ~ImageClassMono();
    // ridimensiona loggetto
    void resize(int r, int c);
    int getHeight();
    int getWidth();
    
    void setHeight(int h);
    void setWidth(int w);

    unsigned char *getInternalPointer()
    { return image; }
};

bool SavePPM(ImageClassRgb &src, const char *filename);
bool SavePGM(ImageClassMono &src, const char *filename);

bool ReadPPM(ImageClassRgb &src, const char *filename);
bool ReadPGM(ImageClassMono &src, const char *filename);

#endif
